/*2017 Uli Beyenbach
*
*Fahrgerät SX für 4 Loks
*V1.01
*
*SX: T0:pin2, T1:pin4, D:pin12
*Taster Lokwahl: 1:pin5, 2:pin6, 3:pin7, 4:pin8
*Taster +:pin14, -:pin15, <>:pin16, Licht:pin0, Horn:pin1
*Taster ZEein:pin9, ZEaus:pin10, halt:pin11
*
*SDA=18, SCL=19
*/

#include <Wire.h> 
#include "LiquidCrystal_I2C.h"  
#include <SX1.h>
#include <EEPROM.h>

byte basis=0;

byte lichtaus[8] = {
  B00000,
  B00000,
  B01110,
  B01010,
  B01110,
  B00000,
  B00000,
};
byte lichtan[8] = {
  B00000,
  B10101,
  B01110,
  B11011,
  B01110,
  B10101,
  B00000,
};
byte hornan[8] = {
  B10011,
  B01011,
  B00101,
  B00101,
  B01011,
  B10011,
  B00011,
};
byte bullit[8] = {
  B00000,
  B01110,
  B11111,
  B11111,
  B11111,
  B01110,
  B00000,
};

byte aktiv,lok,adr,lokalt;
byte lokAdr[]={1,2,3,4};
byte data,ze;
byte verz=100;
byte dt1,dt2,tmp;
unsigned long verzmillis;

/*-----( Declare objects )-----*/
// set the LCD address to 0x27 
LiquidCrystal_I2C lcd(0x27,20,4);

SX sx;

void sxisr(void) {
	// if you want to understand this, see:
	// http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1239522239
	sx.isr();
}

void setup(){
  lcd.begin();  // initialize the lcd for 20 chars 4 lines and turn on backlight
  lcd.backlight();  // backlight on  
  sx.init();    // sx.init(base_address_for_scope_trigger);
  attachInterrupt(0, sxisr, RISING);
  lcd.createChar(2,lichtaus);
  lcd.createChar(1,lichtan);
  lcd.createChar(3,hornan);
  lcd.createChar(4,bullit);
  for(byte i=0;i<4;i++){
    lcd.setCursor(0,i);
    lcd.print("  Lok");
  }
  aktiv=0;
  for(byte i=5;i<12;i++){
    pinMode(i,INPUT_PULLUP);
  }
  for(byte i=14;i<18;i++){
    pinMode(i,INPUT_PULLUP);
  }  
  pinMode(0,INPUT_PULLUP);
  pinMode(1,INPUT_PULLUP);
  data=EEPROM.read(basis);
  if(data>0 && data<100) lokAdr[0]=data;
  data=EEPROM.read(basis+1);
  if(data>0 && data<100) lokAdr[1]=data;
  data=EEPROM.read(basis+2);
  if(data>0 && data<100) lokAdr[2]=data;
  data=EEPROM.read(basis+3);
  if(data>0 && data<100) lokAdr[3]=data;  
  dt1=0;
  dt2=0;
}

void loop(){
  //Tasten abfragen
  if(!digitalRead(5)){
   aktiv=0;  //Lok1
   lok=1;
   for(byte i=0;i<4;i++){
     lcd.setCursor(0,i);
     lcd.print(" ");
   }
   verzmillis=millis();
   while(!digitalRead(5) && dt1>0){
    if(millis()-verzmillis>1000) dt1=0;
   }
   while(!digitalRead(5) && !digitalRead(6)){
    if(millis()-verzmillis>1000){
      if(dt1==0){
        dt1=1;
        anzeigen();
        while(!digitalRead(6)){
          //Leerschleife
        }
      }
    }
   }
  }
  if(!digitalRead(6)){
    aktiv=1;  //Lok2
    lok=1;
    for(byte i=0;i<4;i++){
     lcd.setCursor(0,i);
     lcd.print(" ");
    }
    verzmillis=millis();
    while(!digitalRead(6) && dt1){
     if(millis()-verzmillis>1000) dt1=0;
    }
  }
  if(!digitalRead(7)){
    aktiv=2;  //Lok3
    lok=1;
    for(byte i=0;i<4;i++){
     lcd.setCursor(0,i);
     lcd.print(" ");
   }
   verzmillis=millis();
    while(!digitalRead(7) && dt2){
     if(millis()-verzmillis>1000) dt2=0;
   }
    while(!digitalRead(7) && !digitalRead(8)){
    if(millis()-verzmillis>1000){
      if(dt2==0){
        dt2=1;
        anzeigen();
        while(!digitalRead(8)){
          //Leerschleife
        }
      }
    }
   }
  }
  if(!digitalRead(8)){
    aktiv=3;  //Lok4
    lok=1;
    for(byte i=0;i<4;i++){
     lcd.setCursor(0,i);
     lcd.print(" ");
   }
   verzmillis=millis();
    while(!digitalRead(8) && dt2){
    if(millis()-verzmillis>1000) dt2=0;
   }
  }
  if(digitalRead(5) && digitalRead(6) && digitalRead(7) && digitalRead(8)) lok=0;
  ze=sx.getg();
  if(!digitalRead(9) && ze==0){
    ze=1;
    sx.setg(1);
  }
  if(!digitalRead(10) && ze==1){
    ze=0;
    sx.setg(0);
  }
  if(digitalRead(14) && digitalRead(15)) verz=111;  //weder plus noch minus getastet
  if(lok==0){  //Normalbetrieb ****************************
    if(dt1 && aktiv==1) aktiv=0;
    if(dt2 && aktiv==3) aktiv=2;
    if(!digitalRead(14)){
      data=sx.get(lokAdr[aktiv]);
      data=data & 31;  //Tempo
      data++;
      if(data>31) data=31;
      schreibTempo(data);
      if((dt1 && aktiv==0) || (dt2 && aktiv==2)){
        tmp=aktiv;
        aktiv++;
        schreibTempo(data);
        aktiv=tmp;
      }
      warten();  //Verzögerung für Tastenwiederholung
    }
    if(!digitalRead(15)){
      data=sx.get(lokAdr[aktiv]);
      data=data & 31;  //Tempo
      if(data) data--;
      schreibTempo(data);
      if((dt1 && aktiv==0) || (dt2 && aktiv==2)){
        tmp=aktiv;
        aktiv++;
        schreibTempo(data);
        aktiv=tmp;
      }
      warten();  //Verzögerung für Tastenwiederholung
    }    
  } //Ende Normalbetrieb *********************************************
  if(lok==1){  //Wahl der Lokadresse *********************
    adr=lokAdr[aktiv];
    if(!digitalRead(14)){
      adr++;
      if(adr>99) adr=1;
      lokAdr[aktiv]=adr;
      adrzeigen(); 
      warten();
    }
    if(!digitalRead(15)){
      adr--;
      if(adr<1) adr=99;
      lokAdr[aktiv]=adr;
      adrzeigen(); 
      warten();
    }
  } //Ende Wahl der Lokadresse ***************************************
  if(lok != lokalt){
    lokalt=lok;
    if(lok == 0){  //wechsel nach Lokeinstellung
      EEPROM.write(basis+aktiv,adr);
    }
  }
  if(!digitalRead(16)){  //Richtungswechsel
    data=sx.get(lokAdr[aktiv]);
    byte Richtung=data & B00100000;
    if(Richtung==0){
      Richtung=B00100000;
    }
    else{
      Richtung=0;
    }
    schreibRichtung(Richtung);
    if((dt1 && aktiv==0) || (dt2 && aktiv==2)){
        tmp=aktiv;
        aktiv++;
        schreibRichtung(Richtung);
        aktiv=tmp;
      }
    delay(500);
  }
  if(!digitalRead(0)){  //Licht
    data=sx.get(lokAdr[aktiv]);
    byte licht=data & B01000000;
    if(licht){
      licht=0;
    }
    else{
      licht=B01000000;
    }
    schreibLicht(licht);
    delay(500); //Verzögerung Tastenwiederholung
  }
  if(!digitalRead(1)){  //Horn
    schreibHorn(); //nur Setzen, Rücksetzen macht Sounddekoder
    delay(333);
  }
  if(!digitalRead(11)){  //halt
    schreibTempo(0);
    if((dt1 && aktiv==0) || (dt2 && aktiv==2)){
      tmp=aktiv;
      aktiv++;
      schreibTempo(0);
      aktiv=tmp;
    }
    delay(333);
  }
  
  
  anzeigen();
}

void warten(){
  delay(verz);
  verz=verz-5;
  if(verz<50) verz=50;
}

void schreibTempo(byte tempo){
  byte altdata=sx.get(lokAdr[aktiv]);
  byte sdata=altdata;
  sdata=sdata & B11100000; 
  sdata=sdata+tempo;
  if(sdata != altdata){
    byte test=0;
    while(test<3){
      byte x=sx.set(lokAdr[aktiv],sdata);
      if(x){  //Fehler
        test++;
        delay(100);
      }
      else{
        test=10;  //exit while
      }
    }
  }
  if((dt1 && aktiv==1) || (dt2 && aktiv==3)) return;
  lcd.setCursor(9,aktiv);
  if(tempo<10) lcd.print("0");
  lcd.print(tempo);
}

void schreibRichtung(byte richtung){
  byte altdata=sx.get(lokAdr[aktiv]);
  byte sdata=altdata;
  sdata=sdata & B11011111; 
  sdata=sdata+richtung;
  if(sdata != altdata){
    byte test=0;
    while(test<3){
      byte x=sx.set(lokAdr[aktiv],sdata);
      if(x){  //Fehler
        test++;
        delay(100);
      }
      else{
        test=10;  //exit while
      }
    }
  }
  if((dt1 && aktiv==1) || (dt2 && aktiv==3)) return;
  if(richtung){
    lcd.setCursor(8,aktiv);
    lcd.print("<");
    lcd.setCursor(11,aktiv);
    lcd.print(" ");
  }
  else{
    lcd.setCursor(8,aktiv);
    lcd.print(" ");
    lcd.setCursor(11,aktiv);
    lcd.print(">");
  }
}

void schreibLicht(byte licht){
  byte altdata=sx.get(lokAdr[aktiv]);
  data=altdata;
  data=data & B10111111; 
  data=data+licht;
  if(data != altdata){
    byte test=0;
    while(test<3){
      byte x=sx.set(lokAdr[aktiv],data);
      if(x){  //Fehler
        test++;
        delay(100);
      }
      else{
        test=10;  //exit while
      }
    }
  }
    lcd.setCursor(13,aktiv);
    if(licht){
      lcd.write(1);
    }
    else{
      lcd.write(2);
    }
}

void schreibHorn(){
  byte altdata=sx.get(lokAdr[aktiv]);
  data=altdata;
  data=data | B10000000; 
  if(data != altdata){
    byte test=0;
    while(test<3){
      byte x=sx.set(lokAdr[aktiv],data);
      if(x){  //Fehler
        test++;
        delay(100);
      }
      else{
        test=10;  //exit while
      }
    }
  }
    lcd.setCursor(15,aktiv);
    lcd.write(3);
    //horn wird vom Sounddekoder zurückgesetzt
}

/* 
//Dieser Programmteil schaltet das Horn ein und aus.
//Der obige Programmteil nur ein, da das Horn er vom Sounddekoder ausgeschaltet wird.
//Bei Bedarf obigen Teil "schreibHorn" auskommentieren und diesen hier aktivieren.
void schreibHorn(){
  byte altdata=sx.get(lokAdr[aktiv]);
  byte horn=bitRead(altdata,7);
  data=altdata;
  if(horn){
    data=data & B01111111;
  }
  else{
    dara=data | B10000000;
  }
  if(data != altdata){
    byte test=0;
    while(test<3){
      byte x=sx.set(lokAdr[aktiv],data);
      if(x){  //Fehler
        test++;
        delay(100);
      }
      else{
        test=10;  //exit while
      }
    }
  }
}
*/


void adrzeigen(){
    lcd.setCursor(5,aktiv);
    if(lokAdr[aktiv]<10) lcd.print("0");
    lcd.print(lokAdr[aktiv]);
}

void anzeigen(){
  byte richtung,tempo,licht,horn;
  lcd.setCursor(0,aktiv);
  lcd.write(4);
  if((dt1>0 && aktiv==0) || (dt2>0 && aktiv==2)){
    lcd.setCursor(0,aktiv+1);
    lcd.write(4);
  }
  for(byte i=0;i<4;i++){
   lcd.setCursor(5,i);
   if(lokAdr[i]<10) lcd.print("0");
   lcd.print(lokAdr[i]);
   if((i==1 && dt1) || (i==3 && dt2)){
    lcd.setCursor(8,i);
    lcd.print("Doppeltr.");
   }
   else{
    data=sx.get(lokAdr[i]);
    richtung=bitRead(data,5);
    licht=bitRead(data,6);
    horn=bitRead(data,7);
    tempo=data & 31;
    if(richtung){
      lcd.setCursor(8,i);
      lcd.print("<");
      lcd.setCursor(11,i);
      lcd.print(" ");
    }
    else{
      lcd.setCursor(8,i);
      lcd.print(" ");
      lcd.setCursor(11,i);
      lcd.print(">");
    }
    lcd.setCursor(12,i);
    lcd.print(" ");
    lcd.setCursor(13,i);
    if(licht){
      lcd.write(1);
    }
    else{
      lcd.write(2);
    }
    lcd.setCursor(14,i);
    lcd.print(" ");
    lcd.setCursor(15,i);
    if(horn){
      lcd.write(3);
    }
    else{
      lcd.print(" ");
    }
    lcd.setCursor(16,i);
    lcd.print(" ");
    lcd.setCursor(9,i);
    if(tempo<10) lcd.print("0");
    lcd.print(tempo);
   }
  }
    if(sx.getg()){
      lcd.setCursor(17,1);
      lcd.print("   ");
      lcd.setCursor(17,2);
      lcd.print("   ");
   }
   else{
      lcd.setCursor(17,1);
      lcd.print("ZE ");
      lcd.setCursor(17,2);
      lcd.print("AUS");
  }
}

